import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CostExplorerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CostExplorerClient";
import {
  GetReservationCoverageRequest,
  GetReservationCoverageResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface GetReservationCoverageCommandInput
  extends GetReservationCoverageRequest {}
export interface GetReservationCoverageCommandOutput
  extends GetReservationCoverageResponse,
    __MetadataBearer {}
export declare class GetReservationCoverageCommand extends $Command<
  GetReservationCoverageCommandInput,
  GetReservationCoverageCommandOutput,
  CostExplorerClientResolvedConfig
> {
  readonly input: GetReservationCoverageCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetReservationCoverageCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CostExplorerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetReservationCoverageCommandInput,
    GetReservationCoverageCommandOutput
  >;
  private serialize;
  private deserialize;
}
