import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CostExplorerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CostExplorerClient";
import {
  ListCostAllocationTagsRequest,
  ListCostAllocationTagsResponse,
} from "../models/models_0";
export { __MetadataBearer, $Command };
export interface ListCostAllocationTagsCommandInput
  extends ListCostAllocationTagsRequest {}
export interface ListCostAllocationTagsCommandOutput
  extends ListCostAllocationTagsResponse,
    __MetadataBearer {}
export declare class ListCostAllocationTagsCommand extends $Command<
  ListCostAllocationTagsCommandInput,
  ListCostAllocationTagsCommandOutput,
  CostExplorerClientResolvedConfig
> {
  readonly input: ListCostAllocationTagsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListCostAllocationTagsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CostExplorerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListCostAllocationTagsCommandInput,
    ListCostAllocationTagsCommandOutput
  >;
  private serialize;
  private deserialize;
}
